<?php

/**
 * CorrectionData.php
 * 添削内容を扱う機能郡
 * author 川口
 * 
 * addCorrectionにglobal $dbがあるので、後々修正する、かも。
 */

require_once ('DBAccessor.php');


/*****************
 * public methods*
 *****************/
/**
 * 問題IDと回答文から解答IDのリストを取得する
 */
function getAnswerfromQuestionIDandAnswer($answer, $question_id) {
	// 回答の内容が同じものを取得する
	$query = "SELECT answer_id FROM answer
				WHERE answer.answer = '$answer'
				AND answer.question_id = $question_id";

	connect();
	$findSameResult = mysql_query($query);
	close();
	
	$sameAnswerIDs = null;
	$i = 0;
	if ($findSameResult) {
		while ($row = mysql_fetch_object($findSameResult)) {
			$sameAnswerIDs[$i] = $row->answer_id;
			$i ++;
		}
	} else {
		return;
	}
	return $sameAnswerIDs;
}

/**
 * 未添削な回答に添削する
 * @$answer_id : 添削対象の回答ID
 * @$correction_kind_id : 添削の種類ID
 * @$correction_spot : 添削の対象範囲
 * @$answer_comment : 回答に対するコメント
 */
function addCorrection($answer_id, $correction_kind_id, $correction_spot, $answer_comment) {
	// 添削を追加する
	$query = "INSERT INTO
				correction(correction_kind_id, answer_comment, correction_spot)
				VALUES($correction_kind_id, '$answer_comment', '$correction_spot');";
	connect();
	begin();
	$result = mysql_query($query);
	global $db;
	$correction_id =  mysql_insert_id($db);
	if (!$result) {
		echo("添削の追加に失敗しました");
		rollback();
		close();
		return null;
	}
	
	// 添削オブジェクトを追加する
	$addCorrectionObject =
	"INSERT INTO correction_object(correction_id, answer_id)
	VALUES($correction_id, $answer_id);";
	$addObjectResult = mysql_query($addCorrectionObject);
	if (!$addObjectResult) {
		echo("添削オブジェクトの追加に失敗しました");
		rollback();
		close();
		return null;
	}
	
	// "添削済み"ラベルをつける
	$query2 = "UPDATE answer SET
				answer.is_corrected = 1
				WHERE answer.answer_id = $answer_id";
	$result2 = mysql_query($query2);
	if (!$result2) {
		echo("answerの添削済みラベルの更新に失敗しました");
		rollback();
		close();
		return null;
	}
	
	// 重複した回答を添削する
	correctDuplications($correction_id, $answer_id);

	commit();
	close();

	return $result;
}

/**
 * 添削済みな回答に添削をする
 */
function addRecorrection($answer_id, $correction_kind_id, $correction_spot, $answer_comment) {
	// 添削を追加する
	$query = "INSERT INTO
				correction(correction_kind_id, answer_comment, correction_spot)
				VALUES($correction_kind_id, '$answer_comment', '$correction_spot');";
	connect();
	begin();
	$result = mysql_query($query);
	global $db;
	$correction_id =  mysql_insert_id($db);
	if (!$result) {
		echo("添削の追加に失敗しました");
		rollback();
		close();
		return null;
	}
	
	if($correction_kind_id == 1) {
	// 添削内容が正解だった場合
		// 添削リンクを初期化する
		resetCorrectionObject($answer_id);
	}
	
	// 添削オブジェクトを追加する
	$addCorrectionObject =
	"INSERT INTO correction_object(correction_id, answer_id)
	VALUES($correction_id, $answer_id);";
	$addObjectResult = mysql_query($addCorrectionObject);
	if (!$addObjectResult) {
		echo("添削オブジェクトの追加に失敗しました");
		rollback();
		close();
		return null;
	}
	
	// 重複した回答を添削する
	correctDuplications($correction_id, $answer_id);

	commit();
	close();
}

/**
 * 内容が同じ回答が添削済みだった回答に添削する
 */
function addCorrectionToMirror($correction_id, $answer_id) {
	// 添削リンクを追加する
	$addCorrectionObject =
	"INSERT INTO correction_object(correction_id, answer_id)
		VALUES($correction_id, $answer_id);";
	begin();
	$addObjectResult = mysql_query($addCorrectionObject);
	if (!$addObjectResult) {
		echo("添削オブジェクトの追加に失敗しました");
		rollback();
		return null;
	}
	
	// "添削済み"ラベルをつける
	$query2 = "UPDATE answer SET
				answer.is_corrected = 1
				WHERE answer.answer_id = $answer_id";
	$result2 = mysql_query($query2);
	if (!$result2) {
		echo("answerの添削済みラベルの更新に失敗しました");
		rollback();
		close();
		return null;
	}
	
	commit();
}

/**
 * 未添削な回答郡にある全く同じ回答のIDを取得する
 */
function isInUncorrected($answer, $question_id) {
	$query = "SELECT answer_id FROM answer WHERE
			answer.answer = '$answer' AND answer.question_id = $question_id
			AND answer.is_corrected = FALSE LIMIT 1;";

	connect();
	$result = mysql_query($query);

	if (!$result || mysql_num_rows($result) <= 0) {
		return null;
	}

	$row = mysql_fetch_object($result);

	return $row->answer_id;
}

 /**
 * 重複している回答を添削する
 */
function correctDuplications($correction_id, $answer_id) {
	// 添削をしている回答本文を取得する
	$getAnswer = "SELECT answer.answer, answer.question_id FROM answer
				WHERE answer.answer_id = $answer_id LIMIT 1;";

	$getAnswerResult = mysql_query($getAnswer);
	$answerObject = mysql_fetch_object($getAnswerResult);
	$answer = $answerObject->answer;
	$question_id = $answerObject->question_id;

	// 回答の内容が同じものがあれば、回答IDを取得する
	$findSame = "SELECT answer.answer_id FROM answer
				WHERE answer.answer = '$answer'
				AND answer.question_id = $question_id
				AND answer.answer_id != $answer_id;";
	$findSameResult = mysql_query($findSame);

	if (mysql_num_rows($findSameResult) > 0) {
	// 内容が同じ回答があった場合
		$sameAnswersID = null;
		while ($row = mysql_fetch_object($findSameResult)) {
			$sameAnswersID[] = $row->answer_id;
		}
	} else {
	// 内容が同じ回答がなかった場合
		return;
	}

	foreach ($sameAnswersID as $value) {
		$correctDuplications = "INSERT INTO correction_object(correction_id, answer_id)
							VALUES($correction_id, $value);";

		$correctDuplicationsResult = mysql_query($correctDuplications);
		//黒木が修正します
		//同じ回答があれば、それらも添削済みにする
		$sameCorrectionUpdateString = "UPDATE answer SET
				answer.is_corrected = 1
				WHERE answer.answer_id = $value";
		mysql_query($sameCorrectionUpdateString);		

		if (!$correctDuplicationsResult) {
			echo ("重複している回答の添削編集に失敗しました");
			return;
		}
	}
	
}

/******************
 * private methods*
 ******************/
function resetCorrectionObject($answer_id) {
	$query =
	"SELECT correction_id FROM correction_object
		WHERE correction_object.answer_id = $answer_id;";
		
	$result = mysql_query($query);
	
	$correction = null;
	$i = 0;
	while($row = mysql_fetch_object($result)) {
		$correction[$i] = $row->correction_id;
		
		$i++;
	}
	
	if(count($correction) < 1) return;
	
	foreach($correction as $value) {
		echo("リセット対象添削ID:".$value."<br>");
		deleteCorrection($value);
	}
}
 
 
function deleteCorrection($correction_id) {
	$resetCorrection =
	"DELETE FROM correction_object
		WHERE correction_object.correction_id = $correction_id;";
	echo($resetCorrection);
	$result = mysql_query($resetCorrection);
	if(!$result) {
		echo("添削オブジェクトのリセットに失敗しました");
		return;
	}
}


?>


