<?php
/**
 * QuestionData.php
 * 問題周りのデータを扱う機能郡
 * author 川口
 */
 
require_once ('DBAccessor.php');


/*****************
 * public methods*
 *****************/
/**
 * 出題出来る問題を取得する
 */
function getCandidateQuestion() {
	$query = "SELECT question, question_id, student_visible FROM question
					WHERE question.admin_visible = 1";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$candidate = null;
	while ($row = mysql_fetch_object($result)) {
		$candidate[$i]->question = $row->question;
		$candidate[$i]->question_id = $row->question_id;
		$candidate[$i]->student_visible = $row->student_visible;

		$i ++;
	}

	return $candidate;
}

/**
 * 出題されている問題を取得する
 */
function getSelectedQuestion() {
	$query = "SELECT question, question_id FROM question
					WHERE question.student_visible = TRUE
					ORDER BY question.question_order;";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$selected[] = null;
	while (mysql_num_rows($result) > 0 && $row = mysql_fetch_object($result)) {
		$selected[$i]->question = $row->question;
		$selected[$i]->question_id = $row->question_id;

		$i ++;
	}

	if ($i > 0)
		return $selected;
	else
		return null;
}

/**
 * 問題を追加する
 * デフォルトでadminからは可視、学生からは不可視となる
 * @$question : 問題文
 * @$correct_example : 解答例
 */
function addQuestion($question, $correct_example) {
	$begin = "BEGIN";
	$countGetter = "select count(*) from question;";
	$count = null;
	$query = "INSERT INTO
					question(question, correct_example, question_order, admin_visible, student_visible)
					VALUES('$question', '$correct_example', 7, TRUE, FALSE);";
	$commit = "COMMIT";
	
	connect();
	$beginResult = mysql_query($begin);
	$countGetterResult = mysql_query($countGetter);
	$count = $countGetterResult;
	$result = mysql_query($query);
	$commitResult = mysql_query($commit);
	close();

	return $result;
}

/**
 * adminから不可視にする
 * @$question_id : 問題ID
 */
function adminInvisible($question_id) {
	$query = "UPDATE question SET
			question.admin_visible = FALSE,
			question.student_visible = FALSE
			WHERE question.question_id = $question_id;";

	connect();
	$result = mysql_query($query);
	close();

	return $result;
}

/**
 * 学生が問題を解ける様にする（回答画面から見える様にする）
 * ※adminから不可視で学生から可視にも出来るが、画面仕様上それは出来ない、かも
 */
function studentVisible($question_id) {
	$query = "UPDATE question SET
			question.student_visible = TRUE
			WHERE question.question_id = $question_id;";

	connect();
	$result = mysql_query($query);
	close();

	return $result;
}

/**
 * 学生が問題を解けない様にする（回答画面から見えない様にする）
 * @$question : 問題ID
 */
function studentInvisible($question_id) {
	$query = "UPDATE question SET
			question.student_visible = FALSE
			WHERE question.question_id = $question_id;";

	connect();
	$result = mysql_query($query);
	close();

	return $result;
}

/**
 * 問題の順番を入れ替える
 * @$question_id1 : 並べ替えたい問題その１
 * @$question_id2 : 並べ替えたい問題その２
 */
function swapOrder($tobeSwaped_former, $tobeSwaped_latter) {
	// 順番を交換する片方のデータの現在の順番を取得するSQL文
	$getFormerOrder = "SELECT question_order FROM question
			WHERE question.question_id = $tobeSwaped_former LIMIT 1;";

	// 順番を交換するもう片方のデータの現在の順番を取得するSQL文
	$getLatterOrder = "SELECT question_order FROM question
			WHERE question.question_id = $tobeSwaped_latter LIMIT 1;";

	connect();
	$gotFormerOrder = mysql_query($getFormerOrder);
	$gotLatterOrder = mysql_query($getLatterOrder);

	while ($gotFormerOrder && $row = mysql_fetch_object($gotFormerOrder)) {
		$formerOrder = $row->question_order;
	}
	while ($gotLatterOrder && $row = mysql_fetch_object($gotLatterOrder)) {
		$latterOrder = $row->question_order;
	}

	if ($getFormerOrder && $getLatterOrder) {
		$updateFormer = "UPDATE question SET question.question_order = $latterOrder
					WHERE question.question_id = $tobeSwaped_former;";

		$updateLatter = "UPDATE question SET question.question_order = $formerOrder
					WHERE question.question_id = $tobeSwaped_latter;";

		$resultFormer = mysql_query($updateFormer);
		$resultLatter = mysql_query($updateLatter);

		close();

		return $resultFormer && $resultLatter;
	} else {
		close();
		return false;
	}
}

/**
 * エクセル出力用のデータを取得する
 */
function getExcelSources() {
	$query = "SELECT
				question, correct_example, login_name, clazz, answer, correction_kind,correction_kind_comment,answer_comment
			FROM
				question, student, answer, correction, correction_kind,correction_object
			WHERE answer.question_id = question.question_id
			AND answer.student_login_name = student.login_name
			AND answer.answer_id = correction_object.answer_id
AND correction_object.correction_id = correction.correction_id
			AND correction.correction_kind_id = correction_kind.correction_kind_id
			ORDER BY question.question";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$excel[] = null;
	while ($row = mysql_fetch_object($result)) {
		$excel[$i]->problem = $row->question; // 問題
		$excel[$i]->correctans = $row->correct_example; // 正解例
		$excel[$i]->student = $row->login_name; // ログイン名
		$excel[$i]->classname = $row->clazz; // クラス名
		$excel[$i]->answer = $row->answer; // 学生の回答
		$excel[$i]->mistake = $row->correction_kind; // 間違いの種類
		$excel[$i]->correction_kind_comment = $row->correction_kind_comment; //間違いに対するコメント
		$excel[$i]->answer_comment = $row->answer_comment; //解答に対するコメント

		$i ++;
	}

	return $excel;
}

/**
 * エクセル出力用のデータを問題指定で取得する
 * @$question_id : 問題ID
 */
function getExcelSource($question_id) {
	$query = "SELECT
				question, correct_example, login_name, clazz, answer, correction_kind
			FROM
				question, student, answer, correction, correction_kind
			WHERE question.question_id = $question_id
			AND answer.question_id = question.question_id
			AND answer.student_login_name = student.login_name
			AND answer.answer_id = correction.answer_id
			AND correction.correction_kind_id = correction_kind.correction_kind_id;";

	connect();
	$result = mysql_query($query);
	close();

	$i = 0;
	$excel[] = new Excel();
	while ($row = mysql_fetch_object($result)) {
		$excel[$i]->question = $row->question; // 問題
		$excel[$i]->correct_example = $row->correct_example; // 正解例
		$excel[$i]->login_name = $row->login_name; // ログイン名
		$excel[$i]->clazz = $row->clazz; // クラス名
		$excel[$i]->answer = $row->answer; // 学生の回答
		$excel[$i]->correction_kind = $row->correction_kind; // 間違いの種類

		$i ++;
	}

	return $excel;
}
?>

