<?php


/**
 * 学生の回答データを扱う機能郡
 */
require_once ('TestTools.php');
require_once ('../DBAccessor.php');
require_once ('../AnswerData.php');


/**
 * すべてのテストを実行する
 */
function doAllTests() {
	doTest("getAnswerhistoryTest");
	doTest("getCorrectionTest");
	doTest("getNextToBeCorrectedTest");
	doTest("getCorrectedAnswerTest");
	doTest("addAnswerTest");
	doTest("isInCorrectedTest");
}

doAllTests();


/**
 * 学生が回答した問題の履歴と回答の履歴を取得する
 * @$login : ログイン名
 */
function getAnswerHistoryTest() {
	$getAHTest = getAnswerHistory('s00000aa');
	foreach ($getAHTest as $key => $value) {
		//echo($value->correction->answer_comment."<br>");

		foreach ($value as $walue) {
			echo ($walue . "<br>");
		}

		echo ("<br>");
	}
	
	return true;
}

/**
 * 学生の回答に対する添削を取得する
 * @$answer_id : 回答ID
 */
function getCorrectionTest() {
	$getCorTest = getCorrection(3);
	foreach ($getCorTest as $key => $value) {
		foreach ($value as $walue) {
			echo ($walue . "<br>");
		}

		echo ("<br>");
	}
	
	return true;
}

/**
 * 次に添削される回答を取得する
 */
function getNextToBeCorrectedTest() {
	echo (getNextToBeCorrected());
	
	return true;
}

/**
 * 添削済みの回答のみ取得する
 */
function getCorrectedAnswerTest() {
	$getCrAns = getCorrectedAnswer(1);
	foreach ($getCrAns as $value) {
		echo ($value . "<br>");
	}
	
	return true;
}

/**
 * 回答を追加する
 * @$answer : 回答文
 * @$question_id : 問題ID
 * @$login : ログイン名
 */
function addAnswerTest() {
	$addAnswerTest = addAnswer('よくわからんです(^ω^)', '3', 's22222cc');
	if ($addAnswerTest) {
		echo ("回答が追加されたよ");
		return true;
	} else {
		return false;
	}
}

/**
 * 今までの回答の中に同じ回答が含まれていないか調べる
 */
function isInCorrectedTest() {
	if (($hoge = isInCorrected('あいうえおあ', 2)) != null) {
		echo ("既に添削済みな回答郡に存在している回答だよ！");
		echo ($hoge);
		
		return true;
	} else {
		echo ("添削済みの回答郡の中では初めての回答だったよ");
		
		return false;
	}
}
?>

