<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>中国語研究室 SystemJUN ver.Shige</title>
</head>

<body>

<?php
require_once ("../DBAccessors/QuestionData.php");
$checkedanswers_list = getExcelSources();
function create_html_data($checkedanswers_list) {
	$html_header =<<<EOK
<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>統計データ</title></head><body>
EOK;
	$table_header =<<<EOD
<table><tr>
<td>問題</td>
<td>学生番号</td>
<td>学生のクラス</td>
<td>学生の解答</td>
<td>間違いの種類</td>
<td>間違いに対するコメント</td>
<td>解答に対するコメント</td>
<td>訂正例</td>
</tr>
EOD;

	$table_body = "";
	foreach ($checkedanswers_list as $checkedanswer) {
		$tr_body =<<<EOD
		<tr>
		<td>$checkedanswer->problem</td>
		<td>$checkedanswer->student</td>
		<td>$checkedanswer->classname</td>
		<td>$checkedanswer->answer</td>
		<td>$checkedanswer->mistake</td>
		<td>$checkedanswer->correction_kind_comment</td>
		<td>$checkedanswer->answer_comment</td>
		<td>$checkedanswer->correctans</td>
		</tr>
EOD;
		$table_body = $table_body.$tr_body;
	}
	$table_footer = "</table>";
	$html_footer = "</body></html>";

	$html_data = $html_header.$table_header.$table_body.$table_footer.$html_footer;
	return $html_data;
}
function create_csv_file($checkedanswers_list) {
	$download_day = date("Ymd");
	$csvfilename = $download_day."DATA.xls";
	echo "<a href='".$csvfilename."'>".$csvfilename."</a>";
	$html_data = create_html_data($checkedanswers_list);
	$html_data = mb_convert_encoding($html_data, "UTF-8");
	$fp = fopen($csvfilename, "w");
	fwrite($fp, $html_data);
	fclose($fp);
}
create_csv_file($checkedanswers_list);

echo "<form action='' method='POST'><input type='submit'  name='csvmaker' value='CSVファイルを作成する'>";
?>
 </body></html>