﻿<html>
<head>
<title>中国語研究室 SystemJUN ver.Shige</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head>

<body>
<?php
require_once ("../DBAccessors/MarkingData.php");
require_once ("../Common/AnswerViewCreateTools.php");
define("CORRECTANS_ID", "1");
/*******************
*画面遷移後の処理***
********************/
//選択された問題を取得する
$selected_question = $_POST['question'];
$selected_question_id = $_POST['question_id'];
?>
<h1 align="center">添削編集画面</h1><br><br>
問題：
<?php


//問題を表示する
print "$selected_question";
?>
<br><br><br>
<?php


/****************************************************************
****問題に対する解答をすべて表示し、それに対する添削を表示する***
*****************************************************************/
//echo $selected_question_id;
$answers = getAllAnswersfromQuestionID($selected_question_id);
echo $answers;
$count = 1;
if ($answers) {
	foreach ($answers as $answer) {
		if (answerIsShown($answer->answer, $selected_question_id, $answer->answer_id)) {
			//すでに表示済みだったらなにも表示しない
			return;

		} else {
			print "
															<h4>回答";
			print "$count";
			print "：".$answer->answer."</h4>";
			echo $answer->answer_id;
			show_all_corrections_from_answer($answer->answer_id);
			$count ++;
		}
	}
} else {
	echo "まだ添削はありません";
}

function show_all_corrections_from_answer($answer_id) {
	$correction_sets = getAllCorrectionfromAnswerID($answer_id);
	foreach ($correction_sets as $correction_set) {
		$correction_kind = $correction_set->correction_kind;
		$correction_kind_id = $correction_set->correction_kind_id;
		$correction_spot = $correction_set->correction_spot;
		$answer = $correction_set->answer;
		$answer_id = $correction_set->answer_id;
		$answer_comment = $correction_set->answer_comment;
		$question = $correction_set->question;
		$question_id = $correction_set->question_id;
		$correction_id = $correction_set->correction_id;
		print "添削$correction_id<br>
																添削の種類：$correction_kind<br>";
		show_correction_spot($correction_spot, $answer);
		print "<br>
																コメント：$answer_comment
																<form method = 'post' action=\"Correction_Judge.php\">
																<input type=\"hidden\" name=\"answer_from_edit_marking\" value=\"$answer\" />
																<input type=\"hidden\" name=\"answer_id_from_edit_marking\" value=\"$answer_id\" />
																<input type=\"hidden\" name=\"question_from_edit_marking\" value=\"$question\" />
																<input type=\"hidden\" name=\"question_id_from_edit_marking\" value=\"$question_id\" />
																<input type=\"hidden\" name=\"correction_id_from_edit_marking\" value=\"$correction_id\" />
																";
		show_correction_add_redo_button($correction_kind_id);
	}
}

function show_correction_spot($correction_spot, $question) {
	if ($correction_spot) {
		$marked_answer = make_markedproblem_from_problem_and_number_list($question, $correction_spot);
		print "間違いの位置：".$marked_answer;
	} else {
		print "正解です";
	}
}

function show_correction_add_redo_button($correction_kind_id) {
	if ($correction_kind_id == CORRECTANS_ID) {
		print "<input type=\"submit\" name='redo' value=\"この採点をしなおす\">
																</form><br><br><br>";
	} else {
		print "<input type=\"submit\" name = \"redo\" value=\"この添削をしなおす\">
																<input type=\"submit\" value=\"この回答の添削を追加する\"></form><br><br><br>";
	}

}

/*****
 * 同じ解答がすでに表示されたかどうか調べる
 */
function answerIsShown($answer, $question_id, $answer_id) {
	require_once ('../DBAccessors/AnswerData.php');
	$answerids = isInCorrected_getAnswerIds($answer, $question_id);
	isInCorrected_getAnswerIds($answer, $question_id);
	if ($answerids) {
		$i = 0;
		foreach ($answerids as $answerid) {
			$answer_ids[$i] = $answerid;
			$i ++;
		}
	}
	//配列の一番はじめの要素だけ取り除く（１回だけ表示するため）
	$firstanswer_id = array_shift($answer_ids);
	if ($answer_ids != NULL) {//同じ解答のものが複数あれば
		foreach ($answer_ids as $answerid) {
			if ($answer_id == $answerid) {
            //すでに表示済みならばtrueを返す
				return true;
			} else {
			//表示されていなければfalseを返す
				return false;
			}
		}
	} else {
    //同じ解答のものがなければfalseを返す
		return false;
	}
}
?>


<form action="TeacherTop.php">
<input type="submit" value="トップページに戻る">
</form><br><br>

</body>

</html>