<?php


/**
 * 添削に必要なデータを扱う機能部
 * MegumiAraki 2006/12/20
 */
require_once ('TestTools.php');
require_once ('../DBAccessor.php');
require_once ('../MarkingData.php');

/**
 * すべてのテストを実行する
 */
function doAllTests() {
	doTest("getUnCorrectedAnswerSetTest");
	doTest("deleteCorrectionTest");
	doTest("getAllAnswersfromQuestionIDTest");
	doTest("getAllCorrectionfromAnswerIDTest");
	doTest("getCorrectionKindsTest");
}

doAllTests();

/**
 * 未添削の中で一番最初の回答を取得する
 */
function getUnCorrectedAnswerSetTest() {
	$nextAnswer = getUnCorrectedAnswerSet();
	echo ("次の回答は" . $nextAnswer);

	return true;
}

/**
 * 指定された添削IDの添削を削除する（添削ID、解答ID)
 */
function deleteCorrectionTest() {
	if (deleteCorrection(2, 2)) {
		echo ("削除されたよ");
	} else {
		echo ("削除できなかったよ");
	}

	return true;
}

/**
 * 問題IDから解答をすべて取得する（問題ID)
 */
function getAllAnswersfromQuestionIDTest() {
	$answer = getAllAnswersfromQuestionID(2);
	foreach ($answer as $value) {
		foreach ($value as $walue) {
			echo ($walue."<br>");
		}
	}

	return true;
}

/**
 * 解答IDから添削をすべて取得する（解答ID)
 */
function getAllCorrectionfromAnswerIDTest() {
	$correction = getAllCorrectionfromAnswerID(3);

	foreach ($correction as $value) {
		foreach ($value as $walue) {
			echo ($walue."<br>");
		}
	}

	return true;
}

/**
 * 全ての添削の種類を取得する
 */
function getCorrectionKindsTest() {
	$getCorKindsTest = getCorrectionKinds();
	foreach ($getCorKindsTest as $value) {
		foreach ($value as $walue) {
			echo ($walue . "<br>");
		}
	}
	
	return true;
}
?>

