<?php


/**
 * 学生個々の情報を扱う機能郡
 */
require_once ('TestTools.php');
require_once ('../DBAccessor.php');
require_once ('../StudentData.php');

/**
 * すべてのテストを実行する
 */
function doAllTests() {
	doTest("getpasswordTest");
	doTest("getPasswordTest");
	doTest("getNameTest");
	doTest("getStudentRegisterTest");
	doTest("addStudentTest");
	doTest("updateStudentTest");
}

doAllTests();

/**
 * ログイン名からパスワードを取得する
 * @$login : ログイン名
 */
function getPasswordTest() {
	$getPassTest = getPassword('s22222cc');
	echo ($getPassTest);
	
	return true;
}

/**
 * ログイン名から氏名を取得する
 * @$login : ログイン名
 */
function getNameTest() {
	$getNameTest = getName('s11111bb');
	echo ($getNameTest);
	
	return true;
}

/**
 * 学生の登録情報を取得する
 * ※一応これで登録情報は何でも取って来れる
 * @$login : ログイン名
 */
function getStudentRegisterTest() {
	$getSRTest = getStudentRegister('s00000aa');
	foreach ($getSRTest as $value) {
		echo ($value . "<br>");
	}
	
	return true;
}

/**
 * 学生を新規登録する
 * @$login : ログイン名
 * @$pass : パスワード
 * @$name : 氏名
 * @$class : クラス名
 */
function addStudentTest() {
	$addTest = addStudent('t04040hg', 'hagedaze', 'hage pika', 'intensive1');
	if ($addTest) {
		echo ('追加できたよ');
		
		return true;
	} else {
		return false;
	}
}

/**
 * 学生の情報を更新する
 * @$login : ログイン名
 * @$pass : 新規パスワード
 * @$name : 新規名前
 * @$class : 新規クラス名
 */
function updateStudentTest() {
	$updateTest = updateStudent('s00000aa', 'hogepon', 'mofuge', 'classA');
	if ($updateTest) {
		echo ('更新されたよ');
		
		return true;
	} else {
		return false;
	}
}
?>

