CREATE TABLE problem(
problem_id INTEGER auto_increment primary key NOT NULL,
question VARCHAR(255),
deleteflag INTEGER NOT NULL,
date VARCHAR(255)
)default character set utf8; 

CREATE TABLE unclassifiedanswer(
problem_id INTEGER NOT NULL,
answer_id INTEGER auto_increment primary key NOT NULL,
answer VARCHAR(255),
date VARCHAR(255)
)default character set utf8;

CREATE TABLE correctanswer(
problem_id INTEGER NOT NULL,
answer_id INTEGER auto_increment primary key NOT NULL,
answer VARCHAR(255),
date VARCHAR(255)
)default character set utf8;

CREATE TABLE incorrectanswer(
problem_id INTEGER NOT NULL,
answer_id INTEGER auto_increment primary key NOT NULL,
answer VARCHAR(255),
category_id INTEGER NOT NULL,
comment VARCHAR(255),
range_start VARCHAR(255),
range_end VARCHAR(255),
date VARCHAR(255)
)default character set utf8;

CREATE TABLE category(
category_id INTEGER auto_increment primary key NOT NULL,
category VARCHAR(255),
content VARCHAR(255),
date VARCHAR(255)
)default character set utf8;




INSERT INTO problem(question,deleteflag,date) VALUES('わたしは街を歩いています。',0,'2006年06月10日');
INSERT INTO problem(question,deleteflag,date) VALUES('わたしは中国語の先生です。',0,'2006年06月10日');
INSERT INTO problem(question,deleteflag,date) VALUES('あなたのお父さんの名前はなんですか？',0,'2006年06月10日');
INSERT INTO problem(question,deleteflag,date) VALUES('あなたは学生ですか？',0,'2006年06月10日');
INSERT INTO problem(question,deleteflag,date) VALUES('昨日はなにをしていましたか？',0,'2006年06月10日');