<?


//セッション開始
session_start();
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>中国語研究室 SystemJUN ver.Shige</title>
</head>

<body>
<?php


$correction_state = 0; //添削の状態
define("NEW_CORRECTION", "1");
define("ADD_CORRECTION", "2");
define("OVERWRITE_CORRECTION", "3");

$view_state = 0; //画面の状態
define("FROM_MENU_VIEW", "1");
define("FROM_DONE_VIEW", "2");
define("FROM_EDIT_VIEW", "3");
define("FROM_THIS_VIEW", "4");

//日付を取得する
$today = date('Y年m月d日');

//正解か不正解かを取得する
$correction_kind_id = $_POST['category'];

//echo $correction_kind_id;
if ($correction_kind_id == 1) {
	$correction_spot = NULL;
} else {
	if (isset($_POST["letters"])) {
		if (count($_POST["letters"]) > 0) {
			$correction_spot = join(",", $_POST["letters"]);
		} else {
			$correction_spot = "NOT_SET";
		}
    }else{
		$correction_spot = "NOT_SET";
	}
}
$answer_comment = $_POST['comment'];

include ("../Common/HTMLNormalizer.php");
require_once ("../DBAccessors/CorrectionData.php");
require_once ("../DBAccessors/MarkingData.php");
/*********************************************************/
$answer_comment = normalize($answer_comment);
/*********************************************************/
//セッションから変数を登録
$problem = $_SESSION['PROBLEM'];
$problem_id = $_SESSION['PROBLEM_ID'];
$answer = $_SESSION['ANSWER'];
$answer_id = $_SESSION['ANSWER_ID'];
$correction_state = $_SESSION['CORRECTION_STATE'];
$answer_set = $_SESSION['ANSWER_SET'];

$answer_ids = getAnswerfromQuestionIDandAnswer($answer, $problem_id);

if ($correction_state == OVERWRITE_CORRECTION) {
	//DBから添削データを消去する
	$correction_id = $answer_set->correction_id;
	echo ("削除するID:".$correction_id."<br>");
	deleteCorrectionLink($correction_id);
	addReCorrection($answer_id, $correction_kind_id, $correction_spot, $answer_comment);
}
elseif ($correction_state == ADD_CORRECTION) {
	addReCorrection($answer_id, $correction_kind_id, $correction_spot, $answer_comment);
} else {
	addCorrection($answer_id, $correction_kind_id, $correction_spot, $answer_comment);
}
?>
<h2 align="center">添削が追加されました。</h2>
<table align="center">
<tr><td>
<form method='post' action="Correction_Judge.php">
<input type="submit" name= "same_answer" value="同じ回答をさらに添削する">
</form>
</td></tr>
<tr><td>
<form method='post' action="Correction_Judge.php">
<input type="submit" name="new_correction" value="次の回答を添削する">
</form>
</td></tr>
<tr><td>
<form action="TeacherTop.php">
<input type="submit" value="TOPページに戻る">
</form>
</td></tr>

</table>
</body>
</html>