<?
require_once("Correction_Judge.php");
?>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>中国語研究室 SystemJUN ver.Shige</title>
</head>
<body>


<?
/*******************
*画面遷移後の処理***
********************/

//日付を取得する
$today = date('Y年m月d日');
//添削と画面の状態を取得する
$correction_view_state=getCorrectionAndViewState();
//添削に必要な情報を取得する
$correction_state=$correction_view_state->correction_state;
$view_state-$correction_view_state->view_state;
$answer_set=getDataForCorrection($correction_state,$view_state);

//添削の種類を追加するボタンが押されていたら
//添削の種類を追加する
if($view_state==FROM_THIS_VIEW){
	if(isset($_POST['correction_kind']) && isset($_POST['correction_kind_comment'])){
		$correction_kind=$_POST['correction_kind'];
		$correction_kind_comment=$_POST['correction_kind_comment'];
		$correction_kind_comment = htmlspecialchars($correction_kind_comment);
		addCorrectionKind($correction_kind, $correction_kind_comment);
	}
}

$uneditedanswer=$answer_set->answer;
$uneditedanswerquestion=$answer_set->question;
$uneditedanswerquestionid=$answer_set->question_id;

?>

<h1 align="center">添削画面</h1><br><br>
<table align="center">
<?php
//添削する問題と回答を保存する
$_SESSION['PROBLEM'] = $answer_set->question;
$_SESSION['PROBLEM_ID'] = $answer_set->question_id;
$_SESSION['ANSWER'] = $answer_set->answer;
$_SESSION['ANSWER_ID']=$answer_set->answer_id;
if($uneditedanswer){
	print
	"
	<h3>質問：$uneditedanswerquestion</h3>
	<h3>回答：$uneditedanswer</h3>
	<br>
	";
}else{
	print"<h3>未処理の回答はありません</h3>
	<form>
	<input type=\"button\" onClick=\"location.href='TeacherTop.php'\" value=\"TOPページに戻る\">
	</form>
	";
}
?>

<h4>添削する</h4>
上記の回答が正解の場合、<br>
正解をチェックし、添削完了ボタンを押してください<br><br>
上記の回答が不正解の場合、<br>
不正解をチェックし、不正解の種類を選択し、<br>
不正解の場所とその回答に対するコメントを入れてください。<br>
そして、添削完了ボタンを押してください。<br><br>
不正解の種類はこのページの下方で追加することが出来ます。<br>
詳しくは下方の「不正解の種類を追加する」を参照してください。<br><br><br>

<form method="post" action="Correction_Completed.php" >

添削の種類:
<select name = "category">
<?php
//（不正解）種類DBからデータを読み込む
$correction_kinds=getCorrectionKinds();
//(不正解)種類DBから種類名を取り出し、配列に格納する
echo $correction_kinds;
foreach($correction_kinds as $correction_kind){
	$id=$correction_kind->correction_kind_id;
	$kind=$correction_kind->correction_kind;
	$contant=$correction_kind->correction_kind_comment;
	echo "<option value=".$id.">".$kind.":".$contant."</option><br>";
}
?>
</select>
<br>
間違いの位置：
<?php make_checkboxed_answer($answer_set->answer);
?>
<BR>

コメント：<input type="text" name = "comment" size="50">
<br><br>
<input type="submit" value="添削完了">
</form>
<a href="EditCorrectionQuestionList.php" target="_blank">添削編集画面を表示する</a>

<form method='POST' action="Correction_Judge.php">
<h4>添削の種類を追加する</h4>
添削の種類の名称を決めてください
<br>
例）単語、文型、簡体字<br>
種類名：<input type="text" name ="correction_kind" size="10">
<br><br>
この添削をしたときに表示するコメントを決めてください
<br>
例）単語の間違いです。
<br>
コメント：<input type="text" name ="correction_kind_comment" size="30">
<br><br>
<input type="submit" name ="add_category" value="追加する">
</form>
<br><br><br>
<form>
<input type="button" onClick="location.href='TeacherTop.php'" value="TOPページに戻る">
</form>

</body>
</html>